diff -Naur drupal-7.43/modules/tracker/tracker.info drupal-7.50/modules/tracker/tracker.info
--- drupal-7.43/modules/tracker/tracker.info	2016-02-24 20:51:46.000000000 +0100
+++ drupal-7.50/modules/tracker/tracker.info	2016-07-07 21:08:13.000000000 +0200
@@ -6,8 +6,8 @@
 core = 7.x
 files[] = tracker.test
 
-; Information added by Drupal.org packaging script on 2016-02-24
-version = "7.43"
+; Information added by Drupal.org packaging script on 2016-07-07
+version = "7.50"
 project = "drupal"
-datestamp = "1456343506"
+datestamp = "1467918493"
 
diff -Naur drupal-7.43/modules/tracker/tracker.test drupal-7.50/modules/tracker/tracker.test
--- drupal-7.43/modules/tracker/tracker.test	2016-02-24 20:26:52.000000000 +0100
+++ drupal-7.50/modules/tracker/tracker.test	2016-07-07 20:25:52.000000000 +0200
@@ -151,7 +151,6 @@
 
     $node = $this->drupalCreateNode(array(
       'comment' => 2,
-      'title' => array(LANGUAGE_NONE => array(array('value' => $this->randomName(8)))),
     ));
 
     // Add a comment to the page.
diff -Naur drupal-7.43/modules/translation/tests/translation_test.info drupal-7.50/modules/translation/tests/translation_test.info
--- drupal-7.43/modules/translation/tests/translation_test.info	2016-02-24 20:51:46.000000000 +0100
+++ drupal-7.50/modules/translation/tests/translation_test.info	2016-07-07 21:08:13.000000000 +0200
@@ -5,8 +5,8 @@
 version = VERSION
 hidden = TRUE
 
-; Information added by Drupal.org packaging script on 2016-02-24
-version = "7.43"
+; Information added by Drupal.org packaging script on 2016-07-07
+version = "7.50"
 project = "drupal"
-datestamp = "1456343506"
+datestamp = "1467918493"
 
diff -Naur drupal-7.43/modules/translation/translation.info drupal-7.50/modules/translation/translation.info
--- drupal-7.43/modules/translation/translation.info	2016-02-24 20:51:46.000000000 +0100
+++ drupal-7.50/modules/translation/translation.info	2016-07-07 21:08:13.000000000 +0200
@@ -6,8 +6,8 @@
 core = 7.x
 files[] = translation.test
 
-; Information added by Drupal.org packaging script on 2016-02-24
-version = "7.43"
+; Information added by Drupal.org packaging script on 2016-07-07
+version = "7.50"
 project = "drupal"
-datestamp = "1456343506"
+datestamp = "1467918493"
 
diff -Naur drupal-7.43/modules/trigger/tests/trigger_test.info drupal-7.50/modules/trigger/tests/trigger_test.info
--- drupal-7.43/modules/trigger/tests/trigger_test.info	2016-02-24 20:51:46.000000000 +0100
+++ drupal-7.50/modules/trigger/tests/trigger_test.info	2016-07-07 21:08:13.000000000 +0200
@@ -4,8 +4,8 @@
 core = 7.x
 hidden = TRUE
 
-; Information added by Drupal.org packaging script on 2016-02-24
-version = "7.43"
+; Information added by Drupal.org packaging script on 2016-07-07
+version = "7.50"
 project = "drupal"
-datestamp = "1456343506"
+datestamp = "1467918493"
 
diff -Naur drupal-7.43/modules/trigger/trigger.info drupal-7.50/modules/trigger/trigger.info
--- drupal-7.43/modules/trigger/trigger.info	2016-02-24 20:51:46.000000000 +0100
+++ drupal-7.50/modules/trigger/trigger.info	2016-07-07 21:08:13.000000000 +0200
@@ -6,8 +6,8 @@
 files[] = trigger.test
 configure = admin/structure/trigger
 
-; Information added by Drupal.org packaging script on 2016-02-24
-version = "7.43"
+; Information added by Drupal.org packaging script on 2016-07-07
+version = "7.50"
 project = "drupal"
-datestamp = "1456343506"
+datestamp = "1467918493"
 
diff -Naur drupal-7.43/modules/trigger/trigger.test drupal-7.50/modules/trigger/trigger.test
--- drupal-7.43/modules/trigger/trigger.test	2016-02-24 20:26:52.000000000 +0100
+++ drupal-7.50/modules/trigger/trigger.test	2016-07-07 20:25:52.000000000 +0200
@@ -85,7 +85,7 @@
       $this->assertRaw(t('!post %title has been created.', array('!post' => 'Basic page', '%title' => $edit["title"])), 'Make sure the Basic page has actually been created');
       // Action should have been fired.
       $loaded_node = $this->drupalGetNodeByTitle($edit["title"]);
-      $this->assertTrue($loaded_node->$info['property'] == $info['expected'], format_string('Make sure the @action action fired.', array('@action' => $info['name'])));
+      $this->assertTrue($loaded_node->{$info['property']} == $info['expected'], format_string('Make sure the @action action fired.', array('@action' => $info['name'])));
       // Leave action assigned for next test
 
       // There should be an error when the action is assigned to the trigger
diff -Naur drupal-7.43/modules/update/tests/aaa_update_test.info drupal-7.50/modules/update/tests/aaa_update_test.info
--- drupal-7.43/modules/update/tests/aaa_update_test.info	2016-02-24 20:51:46.000000000 +0100
+++ drupal-7.50/modules/update/tests/aaa_update_test.info	2016-07-07 21:08:13.000000000 +0200
@@ -4,8 +4,8 @@
 core = 7.x
 hidden = TRUE
 
-; Information added by Drupal.org packaging script on 2016-02-24
-version = "7.43"
+; Information added by Drupal.org packaging script on 2016-07-07
+version = "7.50"
 project = "drupal"
-datestamp = "1456343506"
+datestamp = "1467918493"
 
diff -Naur drupal-7.43/modules/update/tests/bbb_update_test.info drupal-7.50/modules/update/tests/bbb_update_test.info
--- drupal-7.43/modules/update/tests/bbb_update_test.info	2016-02-24 20:51:46.000000000 +0100
+++ drupal-7.50/modules/update/tests/bbb_update_test.info	2016-07-07 21:08:13.000000000 +0200
@@ -4,8 +4,8 @@
 core = 7.x
 hidden = TRUE
 
-; Information added by Drupal.org packaging script on 2016-02-24
-version = "7.43"
+; Information added by Drupal.org packaging script on 2016-07-07
+version = "7.50"
 project = "drupal"
-datestamp = "1456343506"
+datestamp = "1467918493"
 
diff -Naur drupal-7.43/modules/update/tests/ccc_update_test.info drupal-7.50/modules/update/tests/ccc_update_test.info
--- drupal-7.43/modules/update/tests/ccc_update_test.info	2016-02-24 20:51:46.000000000 +0100
+++ drupal-7.50/modules/update/tests/ccc_update_test.info	2016-07-07 21:08:13.000000000 +0200
@@ -4,8 +4,8 @@
 core = 7.x
 hidden = TRUE
 
-; Information added by Drupal.org packaging script on 2016-02-24
-version = "7.43"
+; Information added by Drupal.org packaging script on 2016-07-07
+version = "7.50"
 project = "drupal"
-datestamp = "1456343506"
+datestamp = "1467918493"
 
diff -Naur drupal-7.43/modules/update/tests/themes/update_test_basetheme/update_test_basetheme.info drupal-7.50/modules/update/tests/themes/update_test_basetheme/update_test_basetheme.info
--- drupal-7.43/modules/update/tests/themes/update_test_basetheme/update_test_basetheme.info	2016-02-24 20:51:46.000000000 +0100
+++ drupal-7.50/modules/update/tests/themes/update_test_basetheme/update_test_basetheme.info	2016-07-07 21:08:13.000000000 +0200
@@ -3,8 +3,8 @@
 core = 7.x
 hidden = TRUE
 
-; Information added by Drupal.org packaging script on 2016-02-24
-version = "7.43"
+; Information added by Drupal.org packaging script on 2016-07-07
+version = "7.50"
 project = "drupal"
-datestamp = "1456343506"
+datestamp = "1467918493"
 
diff -Naur drupal-7.43/modules/update/tests/themes/update_test_subtheme/update_test_subtheme.info drupal-7.50/modules/update/tests/themes/update_test_subtheme/update_test_subtheme.info
--- drupal-7.43/modules/update/tests/themes/update_test_subtheme/update_test_subtheme.info	2016-02-24 20:51:46.000000000 +0100
+++ drupal-7.50/modules/update/tests/themes/update_test_subtheme/update_test_subtheme.info	2016-07-07 21:08:13.000000000 +0200
@@ -4,8 +4,8 @@
 base theme = update_test_basetheme
 hidden = TRUE
 
-; Information added by Drupal.org packaging script on 2016-02-24
-version = "7.43"
+; Information added by Drupal.org packaging script on 2016-07-07
+version = "7.50"
 project = "drupal"
-datestamp = "1456343506"
+datestamp = "1467918493"
 
diff -Naur drupal-7.43/modules/update/tests/update_test.info drupal-7.50/modules/update/tests/update_test.info
--- drupal-7.43/modules/update/tests/update_test.info	2016-02-24 20:51:46.000000000 +0100
+++ drupal-7.50/modules/update/tests/update_test.info	2016-07-07 21:08:13.000000000 +0200
@@ -5,8 +5,8 @@
 core = 7.x
 hidden = TRUE
 
-; Information added by Drupal.org packaging script on 2016-02-24
-version = "7.43"
+; Information added by Drupal.org packaging script on 2016-07-07
+version = "7.50"
 project = "drupal"
-datestamp = "1456343506"
+datestamp = "1467918493"
 
diff -Naur drupal-7.43/modules/update/update.info drupal-7.50/modules/update/update.info
--- drupal-7.43/modules/update/update.info	2016-02-24 20:51:46.000000000 +0100
+++ drupal-7.50/modules/update/update.info	2016-07-07 21:08:13.000000000 +0200
@@ -6,8 +6,8 @@
 files[] = update.test
 configure = admin/reports/updates/settings
 
-; Information added by Drupal.org packaging script on 2016-02-24
-version = "7.43"
+; Information added by Drupal.org packaging script on 2016-07-07
+version = "7.50"
 project = "drupal"
-datestamp = "1456343506"
+datestamp = "1467918493"
 
diff -Naur drupal-7.43/modules/update/update.settings.inc drupal-7.50/modules/update/update.settings.inc
--- drupal-7.43/modules/update/update.settings.inc	2016-02-24 20:26:52.000000000 +0100
+++ drupal-7.50/modules/update/update.settings.inc	2016-07-07 20:25:52.000000000 +0200
@@ -26,7 +26,7 @@
 
   $form['update_check_disabled'] = array(
     '#type' => 'checkbox',
-    '#title' => t('Check for updates of disabled modules and themes'),
+    '#title' => t('Check for updates of disabled and uninstalled modules and themes'),
     '#default_value' => variable_get('update_check_disabled', FALSE),
   );
 
@@ -98,10 +98,11 @@
  * Form submission handler for update_settings().
  *
  * Also invalidates the cache of available updates if the "Check for updates of
- * disabled modules and themes" setting is being changed. The available updates
- * report needs to refetch available update data after this setting changes or
- * it would show misleading things (e.g., listing the disabled projects on the
- * site with the "No available releases found" warning).
+ * disabled and uninstalled modules and themes" setting is being changed. The
+ * available updates report needs to refetch available update data after this
+ * setting changes or it would show misleading things (e.g., listing the
+ * disabled projects on the site with the "No available releases found"
+ * warning).
  *
  * @see update_settings_validate()
  */
diff -Naur drupal-7.43/modules/user/tests/user_form_test.info drupal-7.50/modules/user/tests/user_form_test.info
--- drupal-7.43/modules/user/tests/user_form_test.info	2016-02-24 20:51:46.000000000 +0100
+++ drupal-7.50/modules/user/tests/user_form_test.info	2016-07-07 21:08:13.000000000 +0200
@@ -5,8 +5,8 @@
 core = 7.x
 hidden = TRUE
 
-; Information added by Drupal.org packaging script on 2016-02-24
-version = "7.43"
+; Information added by Drupal.org packaging script on 2016-07-07
+version = "7.50"
 project = "drupal"
-datestamp = "1456343506"
+datestamp = "1467918493"
 
diff -Naur drupal-7.43/modules/user/tests/user_form_test.module drupal-7.50/modules/user/tests/user_form_test.module
--- drupal-7.43/modules/user/tests/user_form_test.module	2016-02-24 20:26:52.000000000 +0100
+++ drupal-7.50/modules/user/tests/user_form_test.module	2016-07-07 20:25:52.000000000 +0200
@@ -62,3 +62,21 @@
 function user_form_test_current_password_submit($form, &$form_state) {
   drupal_set_message(t('The password has been validated and the form submitted successfully.'));
 }
+
+/**
+ * Implements hook_form_FORM_ID_alter().
+ */
+function user_form_test_form_user_profile_form_alter(&$form, &$form_state) {
+  if (variable_get('user_form_test_user_profile_form_rebuild', FALSE)) {
+    $form['#submit'][] = 'user_form_test_user_account_submit';
+  }
+}
+
+/**
+ * Submit function for user_profile_form().
+ */
+function user_form_test_user_account_submit($form, &$form_state) {
+  // Rebuild the form instead of letting the process end. This allows us to
+  // test for bugs that can be triggered in contributed modules.
+  $form_state['rebuild'] = TRUE;
+}
diff -Naur drupal-7.43/modules/user/user.info drupal-7.50/modules/user/user.info
--- drupal-7.43/modules/user/user.info	2016-02-24 20:51:46.000000000 +0100
+++ drupal-7.50/modules/user/user.info	2016-07-07 21:08:13.000000000 +0200
@@ -9,8 +9,8 @@
 configure = admin/config/people
 stylesheets[all][] = user.css
 
-; Information added by Drupal.org packaging script on 2016-02-24
-version = "7.43"
+; Information added by Drupal.org packaging script on 2016-07-07
+version = "7.50"
 project = "drupal"
-datestamp = "1456343506"
+datestamp = "1467918493"
 
diff -Naur drupal-7.43/modules/user/user.install drupal-7.50/modules/user/user.install
--- drupal-7.43/modules/user/user.install	2016-02-24 20:26:52.000000000 +0100
+++ drupal-7.50/modules/user/user.install	2016-07-07 20:25:52.000000000 +0200
@@ -49,6 +49,9 @@
         'columns' => array('uid' => 'uid'),
       ),
     ),
+    'indexes' => array(
+      'uid_module' => array('uid', 'module'),
+    ),
   );
 
   $schema['role_permission'] = array(
@@ -911,5 +914,14 @@
 }
 
 /**
+ * Ensure there is a combined index on {authmap}.uid and {authmap}.module.
+ */
+function user_update_7019() {
+  // Check first in case it was already added manually.
+  if (!db_index_exists('authmap', 'uid_module')) {
+    db_add_index('authmap', 'uid_module', array('uid', 'module'));
+  }
+}
+/**
  * @} End of "addtogroup updates-7.x-extra".
  */
diff -Naur drupal-7.43/modules/user/user.module drupal-7.50/modules/user/user.module
--- drupal-7.43/modules/user/user.module	2016-02-24 20:26:52.000000000 +0100
+++ drupal-7.50/modules/user/user.module	2016-07-07 20:25:52.000000000 +0200
@@ -424,7 +424,7 @@
 function user_save($account, $edit = array(), $category = 'account') {
   $transaction = db_transaction();
   try {
-    if (!empty($edit['pass'])) {
+    if (isset($edit['pass']) && strlen(trim($edit['pass'])) > 0) {
       // Allow alternate password hashing schemes.
       require_once DRUPAL_ROOT . '/' . variable_get('password_inc', 'includes/password.inc');
       $edit['pass'] = user_hash_password(trim($edit['pass']));
@@ -791,7 +791,7 @@
  *   (optional) The account to check, if not given use currently logged in user.
  *
  * @return
- *   Boolean TRUE if the current user has the requested permission.
+ *   Boolean TRUE if the user has the requested permission.
  *
  * All permission checks in Drupal should go through this function. This
  * way, we guarantee consistent behavior, and ensure that the superuser
@@ -1162,7 +1162,7 @@
   $form['account']['roles'] = array(
     '#type' => 'checkboxes',
     '#title' => t('Roles'),
-    '#default_value' => (!$register && isset($account->roles) ? array_keys($account->roles) : array()),
+    '#default_value' => (!$register && !empty($account->roles) ? array_keys(array_filter($account->roles)) : array()),
     '#options' => $roles,
     '#access' => $roles && user_access('administer permissions'),
     DRUPAL_AUTHENTICATED_RID => $checkbox_authenticated,
@@ -1232,7 +1232,7 @@
     // that prevent them from being empty if they are changed.
     if ((strlen(trim($form_state['values'][$key])) > 0) && ($form_state['values'][$key] != $account->$key)) {
       require_once DRUPAL_ROOT . '/' . variable_get('password_inc', 'includes/password.inc');
-      $current_pass_failed = empty($form_state['values']['current_pass']) || !user_check_password($form_state['values']['current_pass'], $account);
+      $current_pass_failed = strlen(trim($form_state['values']['current_pass'])) == 0 || !user_check_password($form_state['values']['current_pass'], $account);
       if ($current_pass_failed) {
         form_set_error('current_pass', t("Your current password is missing or incorrect; it's required to change the %name.", array('%name' => $name)));
         form_set_error($key);
@@ -1755,9 +1755,11 @@
 
   $items['admin/people/create'] = array(
     'title' => 'Add user',
+    'page callback' => 'user_admin',
     'page arguments' => array('create'),
     'access arguments' => array('administer users'),
     'type' => MENU_LOCAL_ACTION,
+    'file' => 'user.admin.inc',
   );
 
   // Administration pages.
@@ -2165,7 +2167,7 @@
  */
 function user_login_authenticate_validate($form, &$form_state) {
   $password = trim($form_state['values']['pass']);
-  if (!empty($form_state['values']['name']) && !empty($password)) {
+  if (!empty($form_state['values']['name']) && strlen(trim($password)) > 0) {
     // Do not allow any login from the current user's IP if the limit has been
     // reached. Default is 50 failed attempts allowed in one hour. This is
     // independent of the per-user limit to catch attempts from one IP to log
@@ -2256,7 +2258,7 @@
  */
 function user_authenticate($name, $password) {
   $uid = FALSE;
-  if (!empty($name) && !empty($password)) {
+  if (!empty($name) && strlen(trim($password)) > 0) {
     $account = user_load_by_name($name);
     if ($account) {
       // Allow alternate password hashing schemes.
diff -Naur drupal-7.43/modules/user/user.pages.inc drupal-7.50/modules/user/user.pages.inc
--- drupal-7.43/modules/user/user.pages.inc	2016-02-24 20:26:52.000000000 +0100
+++ drupal-7.50/modules/user/user.pages.inc	2016-07-07 20:25:52.000000000 +0200
@@ -44,6 +44,12 @@
     $form['name']['#value'] = $user->mail;
     $form['mail'] = array(
       '#prefix' => '<p>',
+      // As of https://www.drupal.org/node/889772 the user no longer must log
+      // out (if they are still logged in when using the password reset link,
+      // they will be logged out automatically then), but this text is kept as
+      // is to avoid breaking translations as well as to encourage the user to
+      // log out manually at a time of their own choosing (when it will not
+      // interrupt anything else they may have been in the middle of doing).
       '#markup' =>  t('Password reset instructions will be mailed to %email. You must log out to use the password reset link in the e-mail.', array('%email' => $user->mail)),
       '#suffix' => '</p>',
     );
@@ -54,6 +60,11 @@
   return $form;
 }
 
+/**
+ * Form validation handler for user_pass().
+ *
+ * @see user_pass_submit()
+ */
 function user_pass_validate($form, &$form_state) {
   $name = trim($form_state['values']['name']);
   // Try to load by email.
@@ -72,6 +83,11 @@
   }
 }
 
+/**
+ * Form submission handler for user_pass().
+ *
+ * @see user_pass_validate()
+ */
 function user_pass_submit($form, &$form_state) {
   global $language;
 
@@ -96,9 +112,20 @@
   // When processing the one-time login link, we have to make sure that a user
   // isn't already logged in.
   if ($user->uid) {
-    // The existing user is already logged in.
+    // The existing user is already logged in. Log them out and reload the
+    // current page so the password reset process can continue.
     if ($user->uid == $uid) {
-      drupal_set_message(t('You are logged in as %user. <a href="!user_edit">Change your password.</a>', array('%user' => $user->name, '!user_edit' => url("user/$user->uid/edit"))));
+      // Preserve the current destination (if any) and ensure the redirect goes
+      // back to the current page; any custom destination set in
+      // hook_user_logout() and intended for regular logouts would not be
+      // appropriate here.
+      $destination = array();
+      if (isset($_GET['destination'])) {
+        $destination = drupal_get_destination();
+      }
+      user_logout_current_user();
+      unset($_GET['destination']);
+      drupal_goto(current_path(), array('query' => drupal_get_query_parameters() + $destination));
     }
     // A different user is already logged in on the computer.
     else {
@@ -110,8 +137,8 @@
         // Invalid one-time link specifies an unknown user.
         drupal_set_message(t('The one-time login link you clicked is invalid.'), 'error');
       }
+      drupal_goto();
     }
-    drupal_goto();
   }
   else {
     // Time out, in seconds, until login URL expires. Defaults to 24 hours =
@@ -168,6 +195,14 @@
  * Menu callback; logs the current user out, and redirects to the home page.
  */
 function user_logout() {
+  user_logout_current_user();
+  drupal_goto();
+}
+
+/**
+ * Logs the current user out.
+ */
+function user_logout_current_user() {
   global $user;
 
   watchdog('user', 'Session closed for %name.', array('%name' => $user->name));
@@ -176,8 +211,6 @@
 
   // Destroy the current session, and reset $user to the anonymous user.
   session_destroy();
-
-  drupal_goto();
 }
 
 /**
@@ -294,14 +327,18 @@
 }
 
 /**
- * Validation function for the user account and profile editing form.
+ * Form validation handler for user_profile_form().
+ *
+ * @see user_profile_form_submit()
  */
 function user_profile_form_validate($form, &$form_state) {
   entity_form_field_validate('user', $form, $form_state);
 }
 
 /**
- * Submit function for the user account and profile editing form.
+ * Form submission handler for user_profile_form().
+ *
+ * @see user_profile_form_validate()
  */
 function user_profile_form_submit($form, &$form_state) {
   $account = $form_state['user'];
diff -Naur drupal-7.43/modules/user/user.test drupal-7.50/modules/user/user.test
--- drupal-7.43/modules/user/user.test	2016-02-24 20:26:52.000000000 +0100
+++ drupal-7.50/modules/user/user.test	2016-07-07 20:25:52.000000000 +0200
@@ -481,6 +481,34 @@
   }
 
   /**
+   * Test user password reset while logged in.
+   */
+  function testUserPasswordResetLoggedIn() {
+    $account = $this->drupalCreateUser();
+    $this->drupalLogin($account);
+    // Make sure the test account has a valid password.
+    user_save($account, array('pass' => user_password()));
+
+    // Generate one time login link.
+    $reset_url = user_pass_reset_url($account);
+    $this->drupalGet($reset_url);
+
+    $this->assertText('Reset password');
+    $this->drupalPost(NULL, NULL, t('Log in'));
+
+    $this->assertText('You have just used your one-time login link. It is no longer necessary to use this link to log in. Please change your password.');
+
+    $pass = user_password();
+    $edit = array(
+      'pass[pass1]' => $pass,
+      'pass[pass2]' => $pass,
+    );
+    $this->drupalPost(NULL, $edit, t('Save'));
+
+    $this->assertText('The changes have been saved.');
+  }
+
+  /**
    * Attempts login using an expired password reset link.
    */
   function testUserPasswordResetExpired() {
@@ -1849,6 +1877,19 @@
       $this->drupalGet('admin/people');
       $this->assertText($edit['name'], 'User found in list of users');
     }
+
+    // Test that the password '0' is considered a password.
+    $name = $this->randomName();
+    $edit = array(
+      'name' => $name,
+      'mail' => $name . '@example.com',
+      'pass[pass1]' => 0,
+      'pass[pass2]' => 0,
+      'notify' => FALSE,
+    );
+    $this->drupalPost('admin/people/create', $edit, t('Create new account'));
+    $this->assertText(t('Created a new user account for @name. No e-mail has been sent.', array('@name' => $edit['name'])), 'User created with password 0');
+    $this->assertNoText('Password field is required');
   }
 }
 
@@ -1926,6 +1967,74 @@
     $this->drupalLogin($user1);
     $this->drupalLogout();
   }
+
+  /**
+   * Tests setting the password to "0".
+   */
+  public function testUserWith0Password() {
+    $admin = $this->drupalCreateUser(array('administer users'));
+    $this->drupalLogin($admin);
+    // Create a regular user.
+    $user1 = $this->drupalCreateUser(array());
+
+    $edit = array('pass[pass1]' => '0', 'pass[pass2]' => '0');
+    $this->drupalPost("user/" . $user1->uid . "/edit", $edit, t('Save'));
+    $this->assertRaw(t("The changes have been saved."));
+
+    $this->drupalLogout();
+    $user1->pass_raw = '0';
+    $this->drupalLogin($user1);
+    $this->drupalLogout();
+  }
+}
+
+/**
+ * Tests editing a user account with and without a form rebuild.
+ */
+class UserEditRebuildTestCase extends DrupalWebTestCase {
+
+  public static function getInfo() {
+    return array(
+      'name' => 'User edit with form rebuild',
+      'description' => 'Test user edit page when a form rebuild is triggered.',
+      'group' => 'User',
+    );
+  }
+
+  function setUp() {
+    parent::setUp('user_form_test');
+  }
+
+  /**
+   * Test user edit page when the form is set to rebuild.
+   */
+  function testUserEditFormRebuild() {
+    $user1 = $this->drupalCreateUser(array('change own username'));
+    $this->drupalLogin($user1);
+
+    $roles = array_keys($user1->roles);
+    // Save the user form twice.
+    $edit = array();
+    $edit['current_pass'] = $user1->pass_raw;
+    $this->drupalPost("user/$user1->uid/edit", $edit, t('Save'));
+    $this->assertRaw(t("The changes have been saved."));
+    $this->drupalPost(NULL, $edit, t('Save'));
+    $this->assertRaw(t("The changes have been saved."));
+    $saved_user1 = entity_load_unchanged('user', $user1->uid);
+    $this->assertEqual(count($roles), count($saved_user1->roles), 'Count of user roles in database matches original count.');
+    $diff = array_diff(array_keys($saved_user1->roles), $roles);
+    $this->assertTrue(empty($diff), format_string('User roles in database match original: @roles', array('@roles' => implode(', ', $saved_user1->roles))));
+    // Set variable that causes the form to be rebuilt in user_form_test.module.
+    variable_set('user_form_test_user_profile_form_rebuild', TRUE);
+    $this->drupalPost("user/$user1->uid/edit", $edit, t('Save'));
+    $this->assertRaw(t("The changes have been saved."));
+    $this->drupalPost(NULL, $edit, t('Save'));
+    $this->assertRaw(t("The changes have been saved."));
+    $saved_user1 = entity_load_unchanged('user', $user1->uid);
+    $this->assertEqual(count($roles), count($saved_user1->roles), 'Count of user roles in database matches original count.');
+    $diff = array_diff(array_keys($saved_user1->roles), $roles);
+    $this->assertTrue(empty($diff), format_string('User roles in database match original: @roles', array('@roles' => implode(', ', $saved_user1->roles))));
+  }
 }
 
 /**
diff -Naur drupal-7.43/profiles/minimal/minimal.info drupal-7.50/profiles/minimal/minimal.info
--- drupal-7.43/profiles/minimal/minimal.info	2016-02-24 20:51:46.000000000 +0100
+++ drupal-7.50/profiles/minimal/minimal.info	2016-07-07 21:08:13.000000000 +0200
@@ -5,8 +5,8 @@
 dependencies[] = block
 dependencies[] = dblog
 
-; Information added by Drupal.org packaging script on 2016-02-24
-version = "7.43"
+; Information added by Drupal.org packaging script on 2016-07-07
+version = "7.50"
 project = "drupal"
-datestamp = "1456343506"
+datestamp = "1467918493"
 
diff -Naur drupal-7.43/profiles/standard/standard.info drupal-7.50/profiles/standard/standard.info
--- drupal-7.43/profiles/standard/standard.info	2016-02-24 20:51:46.000000000 +0100
+++ drupal-7.50/profiles/standard/standard.info	2016-07-07 21:08:13.000000000 +0200
@@ -24,8 +24,8 @@
 dependencies[] = file
 dependencies[] = rdf
 
-; Information added by Drupal.org packaging script on 2016-02-24
-version = "7.43"
+; Information added by Drupal.org packaging script on 2016-07-07
+version = "7.50"
 project = "drupal"
-datestamp = "1456343506"
+datestamp = "1467918493"
 
diff -Naur drupal-7.43/profiles/testing/modules/drupal_system_listing_compatible_test/drupal_system_listing_compatible_test.info drupal-7.50/profiles/testing/modules/drupal_system_listing_compatible_test/drupal_system_listing_compatible_test.info
--- drupal-7.43/profiles/testing/modules/drupal_system_listing_compatible_test/drupal_system_listing_compatible_test.info	2016-02-24 20:51:46.000000000 +0100
+++ drupal-7.50/profiles/testing/modules/drupal_system_listing_compatible_test/drupal_system_listing_compatible_test.info	2016-07-07 21:08:13.000000000 +0200
@@ -6,8 +6,8 @@
 hidden = TRUE
 files[] = drupal_system_listing_compatible_test.test
 
-; Information added by Drupal.org packaging script on 2016-02-24
-version = "7.43"
+; Information added by Drupal.org packaging script on 2016-07-07
+version = "7.50"
 project = "drupal"
-datestamp = "1456343506"
+datestamp = "1467918493"
 
diff -Naur drupal-7.43/profiles/testing/modules/drupal_system_listing_incompatible_test/drupal_system_listing_incompatible_test.info drupal-7.50/profiles/testing/modules/drupal_system_listing_incompatible_test/drupal_system_listing_incompatible_test.info
--- drupal-7.43/profiles/testing/modules/drupal_system_listing_incompatible_test/drupal_system_listing_incompatible_test.info	2016-02-24 20:51:46.000000000 +0100
+++ drupal-7.50/profiles/testing/modules/drupal_system_listing_incompatible_test/drupal_system_listing_incompatible_test.info	2016-07-07 21:08:13.000000000 +0200
@@ -8,8 +8,8 @@
 core = 6.x
 hidden = TRUE
 
-; Information added by Drupal.org packaging script on 2016-02-24
-version = "7.43"
+; Information added by Drupal.org packaging script on 2016-07-07
+version = "7.50"
 project = "drupal"
-datestamp = "1456343506"
+datestamp = "1467918493"
 
diff -Naur drupal-7.43/profiles/testing/testing.info drupal-7.50/profiles/testing/testing.info
--- drupal-7.43/profiles/testing/testing.info	2016-02-24 20:51:46.000000000 +0100
+++ drupal-7.50/profiles/testing/testing.info	2016-07-07 21:08:13.000000000 +0200
@@ -4,8 +4,8 @@
 core = 7.x
 hidden = TRUE
 
-; Information added by Drupal.org packaging script on 2016-02-24
-version = "7.43"
+; Information added by Drupal.org packaging script on 2016-07-07
+version = "7.50"
 project = "drupal"
-datestamp = "1456343506"
+datestamp = "1467918493"
 
diff -Naur drupal-7.43/scripts/generate-d6-content.sh drupal-7.50/scripts/generate-d6-content.sh
--- drupal-7.43/scripts/generate-d6-content.sh	2016-02-24 20:26:52.000000000 +0100
+++ drupal-7.50/scripts/generate-d6-content.sh	2016-07-07 20:25:52.000000000 +0200
@@ -67,6 +67,7 @@
   ++$voc_id;
   $vocabulary['name'] = "vocabulary $voc_id (i=$i)";
   $vocabulary['description'] = "description of ". $vocabulary['name'];
+  $vocabulary['help'] = "help for ". $vocabulary['name'];
   $vocabulary['nodes'] = $i > 11 ? array('page' => TRUE) : array();
   $vocabulary['multiple'] = $multiple[$i % 12];
   $vocabulary['required'] = $required[$i % 12];
